Package com.sas.services.information.metadata

# Interface AbstractPropertyInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`

All Known Subinterfaces:
  `AssociationPropertyInterface`, `AttributePropertyInterface`, `PropertyInterface`, `PrototypePropertyInterface`

public interface AbstractPropertyInterface extends MetadataInterface

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addCustomizer(SoftwareComponentInterface customizer)`
  Add a customizer to this property.
  `void`
  `addEditor(SoftwareComponentInterface editor)`
  Add an editor to this property.
  `void`
  `addValidator(SoftwareComponentInterface validator)`
  Add a validator to the property.
  `PropertyGroupInterface`
  `getAssociatedPropertyGroup()`
  Get the group, if any, that this property is a member of.
  `List`
  `getCustomizers()`
  Get the list of customizers for this property.
  `List`
  `getEditors()`
  Get the list of SoftwareComponentInterface objects that represent editors for this property.
  `boolean`
  `getIsExpert()`
  Get the isExpert attribute of the property.
  `boolean`
  `getIsLinked()`
  Get the isLinked attribute of the property.
  `boolean`
  `getIsRequired()`
  Get the isRequired attribute of the property.
  `boolean`
  `getIsUpdateable()`
  Get the isUpdateable attribute of the property.
  `boolean`
  `getIsVisible()`
  Get the isVisible attribute from the property.
  `TextStoreInterface`
  `getStoredConfiguration()`
  Get this property's stored configuration.
  `List`
  `getValidators()`
  Get the list of validators for this property.
  `void`
  `removeCustomizer(SoftwareComponentInterface customizer)`
  Remove a customizer from this property.
  `void`
  `removeEditor(SoftwareComponentInterface editor)`
  Remove an editor from this property.
  `void`
  `removeValidator(SoftwareComponentInterface validator)`
  Remove a validator from the property.
  `void`
  `setAssociatedPropertyGroup(PropertyGroupInterface group)`
  Make this property a member of a PropertyGroup.
  `void`
  `setIsExpert(boolean flag)`
  Set the isExpert attribute on the property.
  `void`
  `setIsLinked(boolean flag)`
  Set the isLinked attribute of the property.
  `void`
  `setIsRequired(boolean flag)`
  Set the isRequired attribute of the property.
  `void`
  `setIsUpdateable(boolean flag)`
  Set the isUpdateable attribute of the property.
  `void`
  `setIsVisible(boolean flag)`
  Set the isVisible attribute for the property.
  `void`
  `setStoredConfiguration(TextStoreInterface textStore)`
  Set the TextStoreInterface that contains this property's stored configuration.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getIsVisible

    boolean getIsVisible() throws ServiceException, RemoteException
    Get the isVisible attribute from the property.
    Returns:
      A flag indicating if the property should be visible on a UI.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setIsVisible

    void setIsVisible(boolean flag) throws ServiceException, RemoteException
    Set the isVisible attribute for the property.
    Parameters:
      `flag` - A flag indicating if the property should appear on a UI.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIsUpdateable

    boolean getIsUpdateable() throws ServiceException, RemoteException
    Get the isUpdateable attribute of the property.
    Returns:
      A flag indicating whether the property is updateable via the UI.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setIsUpdateable

    void setIsUpdateable(boolean flag) throws ServiceException, RemoteException
    Set the isUpdateable attribute of the property.
    Parameters:
      `flag` - A flag indicating if the property is updateable via the UI.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIsExpert

    boolean getIsExpert() throws ServiceException, RemoteException
    Get the isExpert attribute of the property.
    Returns:
      A flag indicating if this is an expert-only property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setIsExpert

    void setIsExpert(boolean flag) throws ServiceException, RemoteException
    Set the isExpert attribute on the property.
    Parameters:
      `flag` - A flag indicating if this is an expert-only property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIsLinked

    boolean getIsLinked() throws ServiceException, RemoteException
    Get the isLinked attribute of the property.
    Returns:
      Is this property linked to a property in the prototype object?
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setIsLinked

    void setIsLinked(boolean flag) throws ServiceException, RemoteException
    Set the isLinked attribute of the property.
    Parameters:
      `flag` - Is this property linked to a property in the prototype object?
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIsRequired

    boolean getIsRequired() throws ServiceException, RemoteException
    Get the isRequired attribute of the property.
    Returns:
      A flag indicating whether this property is required for the associated object.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setIsRequired

    void setIsRequired(boolean flag) throws ServiceException, RemoteException
    Set the isRequired attribute of the property.
    Parameters:
      `flag` - A flag indicating whether the property is required for the assocated object.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getAssociatedPropertyGroup

    PropertyGroupInterface getAssociatedPropertyGroup() throws ServiceException, RemoteException
    Get the group, if any, that this property is a member of.
    Returns:
      The PropertyGroup this property is a member of, or null.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setAssociatedPropertyGroup

    void setAssociatedPropertyGroup(PropertyGroupInterface group) throws ServiceException, RemoteException
    Make this property a member of a PropertyGroup.
    Parameters:
      `group` - The PropertyGroup to make this property a member of.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getStoredConfiguration

    TextStoreInterface getStoredConfiguration() throws ServiceException, RemoteException
    Get this property's stored configuration.
    Returns:
      The TextStoreInterface with the property configuration, or null if none exists.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setStoredConfiguration

    void setStoredConfiguration(TextStoreInterface textStore) throws ServiceException, RemoteException
    Set the TextStoreInterface that contains this property's stored configuration.
    Parameters:
      `textStore` - The TextStoreInterface with the property's configuration.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getEditors

    List getEditors() throws ServiceException, RemoteException
    Get the list of SoftwareComponentInterface objects that represent editors for this property.
    Returns:
      A List of SoftwareComponentInterface objects that can edit this property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addEditor

    void addEditor(SoftwareComponentInterface editor) throws ServiceException, RemoteException
    Add an editor to this property.
    Parameters:
      `editor` - A SofwareComponent that can act as an editor for this property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeEditor

    void removeEditor(SoftwareComponentInterface editor) throws ServiceException, RemoteException
    Remove an editor from this property.
    Parameters:
      `editor` - A SoftwareComponent to remove from the editors list.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getCustomizers

    List getCustomizers() throws ServiceException, RemoteException
    Get the list of customizers for this property.
    Returns:
      A List of SoftwareComponentInterface objects that can act as customizers for this property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addCustomizer

    void addCustomizer(SoftwareComponentInterface customizer) throws ServiceException, RemoteException
    Add a customizer to this property.
    Parameters:
      `customizer` - A SoftwareComponentInterface that can act as a customizer for this property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeCustomizer

    void removeCustomizer(SoftwareComponentInterface customizer) throws ServiceException, RemoteException
    Remove a customizer from this property.
    Parameters:
      `customizer` - A SoftwareComponentInterface to remove from the list of customizers.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getValidators

    List getValidators() throws ServiceException, RemoteException
    Get the list of validators for this property.
    Returns:
      A List of SoftwareComponentInterface objects that can validate the state of the property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### addValidator

    void addValidator(SoftwareComponentInterface validator) throws ServiceException, RemoteException
    Add a validator to the property.
    Parameters:
      `validator` - A SoftwareComponentInterface that can validate the state of the property.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeValidator

    void removeValidator(SoftwareComponentInterface validator) throws ServiceException, RemoteException
    Remove a validator from the property.
    Parameters:
      `validator` - A SoftwareComponentInterface to remove from the list of validators.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.